;                   ___    ___
;         MCLR/Vpp |   \__/   | B7  PGD
;     kolona 1  A0 |          | B6  PGC
;     kolona 2  A1 |          | B5
;     kolona 3  A2 |          | B4
;     kolona 4  A3 |          | B3
;     kolona 5  A4 |          | B2
;     kolona 6  A5 |   2525   | B1
;              Vss |          | B0
;     kolona 8  A7 |          | Vdd
;     kolona 7  A6 |          | Vss
;               C0 |          | C7 monostabil trigger
;               C1 |          | C6 dekoder c
;               C2 |          | C5 dekoder b
;               C3 |__________| C4 dekoder a

;-------------------------------- processor definition

	list p=18f2525
	#include <p18f2525.inc>

;-------------------------------- data ram def

	config osc = intio67
	config fcmen = off
	config ieso = off
	config pwrt = on
	config borv = 1
	config wdt = off
	config mclre = off
	config lpt1osc = off
	config pbaden = off
	config stvren = on
	config lvp = off
	config xinst = off
	config debug = off
	config cp0 = off
	config cp1 = off
	config cp2 = off
	config cpb = off
	config cpd = off
	config wrt0 = on
	config wrt1 = on
	config wrt2 = on
	config wrtb = on
	config wrtc = on
	config wrtd = off
	config ebtr0 = off
	config ebtr1 = off
	config ebtr2 = off
	config ebtrb = off

;-------------------------------- data ram definitions

	cblock	0

brojac_redova		; glavni brojac 0...7, odredjuje koji red ce biti upaljen

	endc
;___________________________________________________________________ code

	org	0
	goto	main
	org	8		; int vector
	goto	interrupt
;___________________________________________________________________ tabela

tabela
	db	b'00011000',b'00100100'
	db	b'01000010',b'11000011'
	db	b'11000011',b'11111111'
	db	b'11000011',b'11000011'
;___________________________________________________________________ int 976 Hz

interrupt
	swapf	brojac_redova,w	; brojac redova u W (bitovi 3,2,1,0 idu na 7,6,5,4)
	xorlw	b'01110000'	; jer su redovi inverzni (dole je red 1, a gore 8)
	movwf	portc		; sve to na izlazni port C
	bsf	portc,7
	bcf	portc,7		; impuls na portc,7 da se okine monostabil
;-------------------------------- racunanje pozicije bit-mape u lookup tabeli
	movf	brojac_redova,w
	addlw	tabela		; sada je W na pravoj poziciji u tabeli
	movwf	tblptrl		; ne treba presetovati tblptrh i tblptru, jer su...
				; oni vec automatski bili =0 posle reseta
	tblrd*			; procitaj bajt iz tabele
	movff	tablat,porta	; iz registra citaca tabele direktno na port A
iexit
	incf	brojac_redova,f	; priprema za sledeci red kod sledeceg interrupta
	movlw	07h
	andwf	brojac_redova,f	; resetuj sve bitove na brojacu redova osim 2,1,0
				; (da bi posle 7 odmah presao na 0)
	bcf	intcon,tmr0if	; reset tmr0 int flag
	retfie	fast
;___________________________________________________________________ main

main
	; ----------------------- port control block
	movlw	0fh
	movwf	adcon1,access	; ADC digital I/O, disable ADC
	clrf	porta
	clrf	portb
	clrf	portc		; za pocetak, na svim izlazima su nule
	movlw	b'00000000'
	movwf	trisa,access	; Porta dir (svi pinovi izlazi)
	movlw	b'00000000'
	movwf	trisb,access	; Portb dir (svi pinovi izlazi)
	movlw	b'00000000'
	movwf	trisc,access	; Portc dir (svi pinovi izlazi)
	; ----------------------- tmr0 control block
	movlw	b'11000011'	; 8-bit counter, prescaler 1:32, ukupan faktor...
	movwf	t0con		; ...deljenja 32x256=8192, to je interrupt 976 Hz 
	; ----------------------- oscillator control block
	movlw	b'01110010'
	movwf	osccon		; interni oscilator 8 MHz
	; ----------------------- clear bank 0 ram
	lfsr	0,0		; postavi pointer na 0000h
clram
	clrf	postinc0	; obrisi jedan bajt
	btfss	fsr0h,0		; testiraj bit 0 na visokom bajtu pointera
	bra	clram		; vrati se ako je pointer <256
	;------------------------ interrupt control block
	bsf	intcon,tmr0ie	; enable interrupt on TMR0 overflow
	bsf	intcon,gie	; enable all interrupts
;___________________________________________________________________ farm

farm
	bra	farm		; u redovnom toku programa nema sta da se radi!

	end
